// C Source File
// Created 12/10/2002; 18:01:05
// copyright 2002 Thibaut Chevalier

#include "highscores.h"


void open_hsc(void)
{
	FILE* hsc_file;
	
	EM_moveSymFromExtMem (SYMSTR ("demhsc") ,HS_NULL);	// dsarchive le fichier (si ncessaire)
	hsc_file = fopen("demhsc", "rb");
	if (hsc_file != NULL && (fgetc(hsc_file) == HSC_FILE_CODE))	// si le fichier highscore existe dja et a un bon premier nombre
		{
		fread(highscores, sizeof(HSC_ITEM), 16, hsc_file); // rcupre les donnes highscore
		fread(&optionsData, sizeof(DATA2SAVE), 1, hsc_file);
		copy_game_options();
		}
	else										// si le fichier n'existe pas
		hsc_file = fopen("demhsc", "wb");	// le crer (il sera rempli  le fermeture du programme)
	fclose(hsc_file);	// fermer le fichier
}


void close_hsc(void)
{
	FILE* hsc_file;

	hsc_file = fopen("demhsc", "wb");	// ouvre le fichier
	fputc(HSC_FILE_CODE, hsc_file);	// crit le caractre spcial en premier dans le ficiher
	fwrite(highscores, sizeof(HSC_ITEM), 16, hsc_file); // recopie les donnes highscore
	fwrite(&optionsData, sizeof(DATA2SAVE), 1, hsc_file);	// recopie les options et prfrences
	fputc(0,hsc_file);
  fputs("dem",hsc_file);
  fputc(0,hsc_file);
  fputc(OTH_TAG,hsc_file);
	fclose(hsc_file);	// fermer le fichier
	EM_moveSymToExtMem (SYMSTR ("demhsc") ,HS_NULL);	// r-archive le fichier
}



void new_entry(short tab, long score)
{
	short pos; // indique une position dans la table des highscores
	char buffer[70];
	
	if (score >= highscores[tab][6].score)	// si nouveau meilleur score
		{
		for (pos = 7; (score >= highscores[tab][pos - 1].score) && pos; pos--)
			memcpy(&highscores[tab][pos], &highscores[tab][pos-1], sizeof(HSC_ITEM));
	
		highscores[tab][pos].score = score;
		
		frame(24 + XOFFSET, 55 + YOFFSET, 111, 14, Vscreen);
		sprintf(buffer, "Congratulations %s !", optionsData.playerName);
		DrawStr(26 + XOFFSET, 57 + YOFFSET, buffer , A_NORMAL);
		
		sprintf(buffer, "New highscore at place n\xb0 %d", pos + 1);
		DrawStr(26 + XOFFSET, 64 + YOFFSET, buffer , A_NORMAL);
		memcpy(LCD_MEM, Vscreen, LCD_SIZE);
		
		memcpy(highscores[tab][pos].ptrName, optionsData.playerName, 8);
		}
}



void disp_hsc_tabl(short tab)
{
	short i;
	char buffer[45];
	
	if (tab == 0) DrawStr(XOFFSET + 41, 32, "Hall of Fame :: Arcade", A_NORMAL);
	else DrawStr(XOFFSET + 35, 32, "Hall of Fame :: Simulation", A_NORMAL);
	FastDrawLine(Vscreen, 0, 38, LCD_WIDTH - 1, 38, A_NORMAL);
	
	for (i = 0; i <= 6; i++)
		{
	#ifdef COMPILE_FOR_TI89
		sprintf(buffer, "%d:", i+1);
		DrawStr(39, 42 + (7 * i), buffer, A_NORMAL);
		DrawStr(47, 42 + (7 * i), highscores[tab][i].ptrName, A_NORMAL);
		sprintf(buffer, "%ld", highscores[tab][i].score);
		DrawStr(104, 42 + (7 * i), buffer, A_NORMAL);
	#endif
	
	#ifdef COMPILE_FOR_TI92PLUS
		FontSetSys(F_6x8);	// crire en gros pour la TI92+
		sprintf(buffer, "%d. ", i+1);
		DrawStr(69, 50 + (9 * i), buffer, A_NORMAL);
		DrawStr(85, 50 + (9 * i), highscores[tab][i].ptrName, A_NORMAL);
		sprintf(buffer, "%ld", highscores[tab][i].score);
		DrawStr(155, 50 + (9 * i), buffer, A_NORMAL);
		FontSetSys(F_4x6);	// remettre par dfaut la petite police
	#endif
		}
}
