// C Header File
// Created 16/11/2002; 16:10:43
// C Header File
// Created 07/11/2002; 23:08:39

#include "const.h" // constantes, librairies
#include "extgraph.h"

/******************************************* Donnes Texte *****************************************/
						
// Texte du menu principal
	TextPage mainMenuPage = {6,{"Play", "Options", "Controls", "Highscores", "Credits", "Exit"},
													{{10 + SPEOFFSET, 42 + YOFFSET},{10 + SPEOFFSET, 49 + YOFFSET},{10 + SPEOFFSET, 56 + YOFFSET},{10 + SPEOFFSET, 63 + YOFFSET},{10 + SPEOFFSET, 70 + YOFFSET},{10 + SPEOFFSET, 77 + YOFFSET}} };

	TextPage playMenuPage = {3,{"Asteroids field", "Training", "Change player name"},
													{{10 + SPEOFFSET, 42 + YOFFSET},{10 + SPEOFFSET, 49 + YOFFSET},{10 + SPEOFFSET, 63 + YOFFSET}} };
	
	TextPage optionsMenuPage =	{4,{"Change player name", "Ship controls", "Asteroids' trajectory", "Default camera mode"},
															{{10 + SPEOFFSET, 42 + YOFFSET},{10 + SPEOFFSET, 49 + YOFFSET},{10 + SPEOFFSET, 56 + YOFFSET},{10 + SPEOFFSET, 63 + YOFFSET}} };
										
										
// Texte de l'cran keys
#ifdef COMPILE_FOR_TI89
	TextPage keysPage = {8,{":: Keys ::", "Arrows :: move the ship", "Esc/Apps :: move away/closer", "2nd :: fire laser cannons", "Diamond :: fire a remote missile", "F1/F2 :: select camera mode", "Shift :: pause the game", "Clear :: quit the game"},
										{{63 + XOFFSET, 32},{2 + XOFFSET, 42 + YOFFSET},{2 + XOFFSET, 49 + YOFFSET},{2 + XOFFSET, 56 + YOFFSET},{2 + XOFFSET, 63 + YOFFSET},{2 + XOFFSET, 70 + YOFFSET},{2 + XOFFSET, 77 + YOFFSET},{2 + XOFFSET, 84 + YOFFSET}} };
#else
	TextPage keysPage = {8,{":: Keys ::", "Arrows :: move the ship", "F2/F6 :: move away/closer", "F1 :: fire laser cannons", "F5 :: fire a remote missile", "F3/F7 :: select camera mode", "Apps :: pause the game", "Esc :: quit the game"},
										{{63 + XOFFSET, 32},{2 + XOFFSET, 42 + YOFFSET},{2 + XOFFSET, 49 + YOFFSET},{2 + XOFFSET, 56 + YOFFSET},{2 + XOFFSET, 63 + YOFFSET},{2 + XOFFSET, 70 + YOFFSET},{2 + XOFFSET, 77 + YOFFSET},{2 + XOFFSET, 84 + YOFFSET}} };
#endif

// Texte de l'cran keys
	TextPage creditsPage = {7,{"Space Dementia version beta 0.8", "Programmed by Thibaut Chevalier", "Compiled on ", __DATE__, "For comments, suggestions, bug reports,", "e-mail : moitib@fr.st", "For latest updates, visit my website :"},
										{{2 + XOFFSET, 34 + YOFFSET},{2 + XOFFSET, 41 + YOFFSET},{2 + XOFFSET, 48 + YOFFSET},{45 + XOFFSET, 48 + YOFFSET},{2 + XOFFSET, 63 + YOFFSET},{2 + XOFFSET, 70 + YOFFSET},{2 + XOFFSET, 84 + YOFFSET}}};
										
// Texte du menu pause
	TextPage pausePage = {5,{":: Pause menu ::", "Resume the game", "Autodestruction", "Turn off the calc", "Exit the program"},
										{{52 + XOFFSET, 4 + YOFFSET},{49 + XOFFSET, 13 + YOFFSET},{49 + XOFFSET, 20 + YOFFSET},{49 + XOFFSET, 27 + YOFFSET},{49 + XOFFSET, 34 + YOFFSET}}};


/****************************************** Menus *************************************************/

	MenuItem Menus[] = {	{&mainMenuPage, {"Play in training or Asteroid mode", "Check / change the options and preferences", "Learn which keys to use to play", "Have a look at the hall of fame !", "Information about the program", "Quit Space Dementia"}, {PLAY_MENU_ID, OPTIONS_MENU_ID, CONTROLS_MENU_ID, HIGH_MENU_ID, CREDITS_MENU_ID, EXIT_MENU_ID}}, // Main menu
												{&playMenuPage, {"Destroy 'em all !", "Fly trough the rings in training mode !", "Current name : _       ", NULL, NULL, NULL}, {COMPET_MENU_ID, TRAINING_MENU_ID, CHGNAME_MENU_ID, EMPTY, EMPTY, EMPTY}}, // Menu Play
												{&optionsMenuPage, {"Current name : _       ", "Current mode : Arcade    ", "Current trajectory : Line    ", "Current default camera mode : Fixed      ", NULL, NULL} , {CHGNAME_MENU_ID, CTMOD_MENU_ID, TRAJ_MENU_ID, DEF_CAM_MENU_ID, EMPTY, EMPTY}} 	// Menu Options
										 };
	
	DATA2SAVE optionsData = {"_       ", ARCADE, LINE, FIX};
										 	
/**************************************** Dclarations de fonctions **********************************/
	
	short run_menu(short);
	void anim_title(void);
	void input_str(char*);
	void copy_game_options(void);
	
/***************************************** donnes externes *****************************************/
	
	extern void *Vscreen; // pointeur sur l'cran Virtuel
	extern void exit_proc(short); // defini dans main.c
	extern short ship_selection(void); 	// defini dans game.c
	extern void game(short, short); 	// defini dans game.c
	extern void camera_set(short, short, short);	// defini dans game.c
	extern void ship_set(short, short, short, short, short, short, short); 	// defini dans game.c
	extern void set_screen_center(short, short); 	// defini dans game.c
	extern void draw_intro_ship(short); 	// defini dans game.c
	extern void turn_ship_y(short); 	// defini dans game.c
	extern void disp_hsc_tabl(short);	// defini dans highscores.c
	extern void input_str(char*); // dfini dans menu.c
	extern INT_HANDLER save_int_1;	// variable utilise pour sauver l'tat de l'auto-interruption 1
	extern void enable_timer(void);
  extern void disable_timer(void);
 	extern DATA2SAVE optionsData;	// structure qui contient les rglages des options
	extern void frame(short, short, short, short, void*); // dessine un zoli cadre
	
	extern unsigned char title_pic[]; // image titre